CREATE TABLE IF NOT EXISTS `CFG_ServerAFKChannelIdsHistory`
(
    `Id`    BIGINT(20)  NOT NULL,
    `ChannelId` BIGINT NOT NULL,
    `ServerId` BIGINT NOT NULL,
    `Deleted` BOOL DEFAULT FALSE,
    `DateFrom` DATETIME(6) NOT NULL,
    `DateTo` DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_CFG_ServerAFKChannelIdsUpdate`;

CREATE TRIGGER `TR_CFG_ServerAFKChannelIdsUpdate`
    AFTER UPDATE
    ON `CFG_ServerAFKChannelIds`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerAFKChannelIdsHistory` (
        `Id`,
        `ChannelId`,
        `ServerId`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.ChannelId,
        OLD.ServerId,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_CFG_ServerAFKChannelIdsDelete`;

CREATE TRIGGER `TR_CFG_ServerAFKChannelIdsDelete`
    AFTER DELETE
    ON `CFG_ServerAFKChannelIds`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerAFKChannelIdsHistory` (
        `Id`,
        `ChannelId`,
        `ServerId`,
        `Deleted`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.ChannelId,
        OLD.ServerId,
        TRUE,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;