ALTER TABLE `Levels`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `Levels`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `LevelsHistory`
(
    `Id`            BIGINT(20)   NOT NULL,
    `Name`          VARCHAR(255) NOT NULL,
    `Color`         VARCHAR(8)   NOT NULL,
    `MinXp`         BIGINT(20)   NOT NULL,
    `PermissionInt` BIGINT(20)   NOT NULL,
    `ServerId`      BIGINT(20) DEFAULT NULL,
    `Deleted`       BOOL       DEFAULT FALSE,
    `DateFrom`      DATETIME(6)  NOT NULL,
    `DateTo`        DATETIME(6)  NOT NULL
);

DROP TRIGGER IF EXISTS `TR_LevelsUpdate`;

CREATE TRIGGER `TR_LevelsUpdate`
    AFTER UPDATE
    ON `Levels`
    FOR EACH ROW
BEGIN
    INSERT INTO `LevelsHistory` (
        `Id`, `Name`, `Color`, `MinXp`, `PermissionInt`, `ServerId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Name, OLD.Color, OLD.MinXp, OLD.PermissionInt, OLD.ServerId, OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_LevelsDelete`;

CREATE TRIGGER `TR_LevelsDelete`
    AFTER DELETE
    ON `Levels`
    FOR EACH ROW
BEGIN
    INSERT INTO `LevelsHistory` (
        `Id`, `Name`, `Color`, `MinXp`, `PermissionInt`, `ServerId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Name, OLD.Color, OLD.MinXp, OLD.PermissionInt, OLD.ServerId, TRUE, OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;